Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java	(revision 25635)
@@ -36,4 +36,5 @@
 
 import java.io.File;
+import java.io.Serializable;
 import java.util.ArrayList;
 import java.util.HashMap;
@@ -118,5 +119,5 @@
 			return result;
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String oid = (String) params.get(GSXML.NODE_ID_ATT);
@@ -148,5 +149,5 @@
 			return result;
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String srcFile = (String) params.get("sourcefile"); //TODO: Replace with a constant
@@ -182,5 +183,5 @@
 			return result;
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String oid = (String) params.get(GSXML.NODE_ID_ATT);
@@ -317,5 +318,5 @@
 			return result;
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String oid = (String) params.get(GSXML.NODE_ID_ATT);
@@ -333,5 +334,5 @@
 		for (int i = 1; i < assocFiles.size(); i++)
 		{
-			metadataList.appendChild(GSXML.createMetadataElement(this.doc, "assocfile", (String) assocFiles.get(i)));
+			metadataList.appendChild(GSXML.createMetadataElement(this.doc, "assocfile", assocFiles.get(i)));
 		}
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java	(revision 25635)
@@ -32,4 +32,5 @@
 
 import java.io.File;
+import java.io.Serializable;
 import java.util.HashMap;
 import java.util.Vector;
@@ -115,5 +116,5 @@
 			return result;  
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		
 		String oid = (String) params.get("oid");
@@ -152,5 +153,5 @@
 			return result;  
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		
 		String srcFile = (String) params.get("srcfile");
@@ -223,5 +224,5 @@
 			return result;  
 		}
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		
 		String oid = (String) params.get("oid");
@@ -269,5 +270,5 @@
 		
 		String srcFile = info.getInfo("src-file");
-		Vector data = info.getMultiInfo("assoc-file");
+		Vector<String> data = info.getMultiInfo("assoc-file");
 		
 		Element metadataList = this.doc.createElement(GSXML.METADATA_ELEM + GSXML.LIST_MODIFIER);
@@ -276,5 +277,5 @@
 		for (int i = 0; i < data.size(); i++)
 		{
-			metadataList.appendChild(createMetadataElement("assocfile", (String)data.get(i)));
+			metadataList.appendChild(createMetadataElement("assocfile", data.get(i)));
 		}
 		
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/Authentication.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/Authentication.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/Authentication.java	(revision 25635)
@@ -18,4 +18,5 @@
 import java.util.regex.Pattern;
 import java.io.File;
+import java.io.Serializable;
 
 import net.tanesha.recaptcha.ReCaptchaImpl;
@@ -230,5 +231,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(paramList, true);
+		HashMap<String, Serializable> params = GSXML.extractParams(paramList, true);
 
 		String username = (String) params.get("username");
@@ -308,5 +309,5 @@
 			return result; // Return the empty result
 		}
-		HashMap paramMap = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> paramMap = GSXML.extractParams(param_list, false);
 		String op = (String) paramMap.get("authpage");
 		serviceNode.setAttribute("operation", op);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 25635)
@@ -35,4 +35,5 @@
 import org.greenstone.gsdl3.util.UserContext;
 
+import java.io.Serializable;
 import java.net.InetAddress;
 import java.util.Properties;
@@ -66,6 +67,6 @@
 	protected static final int delay = 1800000;
 
-	protected Hashtable userMap = null;
-	protected Hashtable timerMap = null;
+	protected Hashtable<String, Hashtable<String, Hashtable<String, Item>>> userMap = null;
+	protected Hashtable<String, UserTimer> timerMap = null;
 	protected String username = "";
 	protected String password = "";
@@ -74,9 +75,9 @@
 	public BerryBasket()
 	{
-		userMap = new Hashtable();
-		timerMap = new Hashtable();
-	}
-
-	private Hashtable updateDocMap(Element request)
+		userMap = new Hashtable<String, Hashtable<String, Hashtable<String, Item>>>();
+		timerMap = new Hashtable<String, UserTimer>();
+	}
+
+	private Hashtable<String, Hashtable<String, Item>> updateDocMap(Element request)
 	{
 
@@ -87,8 +88,8 @@
 			if (timerMap.containsKey(id))
 			{
-				UserTimer timer = (UserTimer) timerMap.get(id);
+				UserTimer timer = timerMap.get(id);
 				timer.restart();
 			}
-			return (Hashtable) userMap.get(id);
+			return userMap.get(id);
 		}
 		else
@@ -97,5 +98,5 @@
 			timerMap.put(id, timer);
 			timer.start();
-			Hashtable newDocs = new Hashtable();
+			Hashtable<String, Hashtable<String, Item>> newDocs = new Hashtable<String, Hashtable<String, Item>>();
 			userMap.put(id, newDocs);
 			return newDocs;
@@ -210,5 +211,5 @@
 	protected Element processAddItem(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -223,5 +224,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String item = (String) params.get("item");
@@ -236,5 +237,5 @@
 		if (docsMap.containsKey(collection))
 		{
-			Hashtable items = (Hashtable) docsMap.get(collection);
+			Hashtable<String, Item> items = docsMap.get(collection);
 			if (!items.containsKey(item))
 			{
@@ -246,5 +247,5 @@
 		else
 		{
-			Hashtable items = new Hashtable();
+			Hashtable<String, Item> items = new Hashtable<String, Item>();
 			Item newItem = generateItem(collection, item);
 			items.put(item, newItem);
@@ -261,5 +262,5 @@
 		Item item = new Item(collection, id);
 		String to = GSPath.appendLink(collection, "DocumentMetadataRetrieve");
-		ArrayList tmp = new ArrayList();
+		ArrayList<String> tmp = new ArrayList<String>();
 		tmp.add(id);
 		
@@ -303,5 +304,5 @@
 	protected Element processDeleteItems(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -317,5 +318,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String param = (String) params.get("items");
@@ -341,5 +342,5 @@
 			if (docsMap.containsKey(collection))
 			{
-				Hashtable itemMap = (Hashtable) docsMap.get(collection);
+				Hashtable itemMap = docsMap.get(collection);
 				if (itemMap.containsKey(item))
 				{
@@ -359,5 +360,5 @@
 	protected Element processDeleteItem(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -373,5 +374,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String param = (String) params.get("item");
@@ -393,5 +394,5 @@
 		if (docsMap.containsKey(collection))
 		{
-			Hashtable itemMap = (Hashtable) docsMap.get(collection);
+			Hashtable itemMap = docsMap.get(collection);
 			if (itemMap.containsKey(item))
 			{
@@ -409,5 +410,5 @@
 	protected Element processItemNum(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -416,9 +417,9 @@
 		int size = 0;
 		String ids = "";
-		Iterator keys = docsMap.keySet().iterator();
+		Iterator<String> keys = docsMap.keySet().iterator();
 
 		while (keys.hasNext())
 		{
-			Hashtable items = (Hashtable) docsMap.get((String) keys.next());
+			Hashtable items = docsMap.get(keys.next());
 			size += items.size();
 			Iterator values = items.values().iterator();
@@ -437,5 +438,5 @@
 	}
 
-	private Element getDocumentMetadata(String to, UserContext userContext, Iterator ids)
+	private Element getDocumentMetadata(String to, UserContext userContext, Iterator<String> ids)
 	{
 
@@ -446,5 +447,5 @@
 
 		// Create a parameter list to specify the required metadata information
-		HashSet meta_names = new HashSet();
+		HashSet<String> meta_names = new HashSet<String>();
 		meta_names.add("Title"); // the default
 		meta_names.add("root_Title");
@@ -454,8 +455,8 @@
 
 		Element param = null;
-		Iterator i = meta_names.iterator();
+		Iterator<String> i = meta_names.iterator();
 		while (i.hasNext())
 		{
-			String name = (String) i.next();
+			String name = i.next();
 			param = this.doc.createElement(GSXML.PARAM_ELEM);
 			param_list.appendChild(param);
@@ -476,5 +477,5 @@
 			Element dm_doc_node = this.doc.createElement(GSXML.DOC_NODE_ELEM);
 			dm_doc_list.appendChild(dm_doc_node);
-			dm_doc_node.setAttribute(GSXML.NODE_ID_ATT, (String) ids.next());
+			dm_doc_node.setAttribute(GSXML.NODE_ID_ATT, ids.next());
 		}
 
@@ -485,15 +486,15 @@
 	protected Element processDisplayList(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
 		Element result = this.doc.createElement(GSXML.RESPONSE_ELEM);
 
-		Iterator keys = docsMap.keySet().iterator();
+		Iterator<String> keys = docsMap.keySet().iterator();
 
 		while (keys.hasNext())
 		{
-			String collection = (String) keys.next();
-			Hashtable items = (Hashtable) docsMap.get(collection);
+			String collection = keys.next();
+			Hashtable items = docsMap.get(collection);
 			Iterator itemItr = items.values().iterator();
 
@@ -534,5 +535,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String to = (String) params.get("address");
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CoverageMetadataRetrieve.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CoverageMetadataRetrieve.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CoverageMetadataRetrieve.java	(revision 25635)
@@ -198,14 +198,14 @@
     DBInfo collection_info = this.coll_db.getInfo("collection");
     
-    Set keys = collection_info.getKeys();
-
-    Vector valid_keys = new Vector();
+    Set<String> keys = collection_info.getKeys();
+
+    Vector<String> valid_keys = new Vector<String>();
 
     // Iterate over keys and add valid ones to the valid_keys vector
     String current_key = null;
-    Iterator iter = keys.iterator();
+    Iterator<String> iter = keys.iterator();
 
     while (iter.hasNext()) {
-        current_key = (String) iter.next();
+        current_key = iter.next();
         if(current_key.matches("^metadatalist-([a-zA-Z][^-])*$"))
         {
@@ -232,5 +232,5 @@
 
     while (iter.hasNext()) {
-        current_key = (String) iter.next();
+        current_key = iter.next();
 
         // Create metadataSet using the current key and add to metadataSetList
@@ -244,8 +244,8 @@
 
         // Create a metadata element for each value and add to metadataSet
-        Vector sub_info = collection_info.getMultiInfo(current_key);
-        Iterator iter2 = sub_info.iterator();
+        Vector<String> sub_info = collection_info.getMultiInfo(current_key);
+        Iterator<String> iter2 = sub_info.iterator();
         while (iter2.hasNext()) {
-            value = (String) iter2.next();     
+            value = iter2.next();     
             metadata = this.doc.createElement("metadata");
             metadata.setAttribute(GSXML.NAME_ATT, value);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java	(revision 25635)
@@ -292,6 +292,6 @@
 		logger.debug("metadata response = " + this.converter.getPrettyString(metadata_response));
 		NodeList coll_responses = metadata_response.getElementsByTagName(GSXML.RESPONSE_ELEM);
-		ArrayList valid_colls = new ArrayList();
-		ArrayList valid_coll_names = new ArrayList();
+		ArrayList<String> valid_colls = new ArrayList<String>();
+		ArrayList<String> valid_coll_names = new ArrayList<String>();
 		for (int i = 0; i < coll_responses.getLength(); i++)
 		{
@@ -317,5 +317,5 @@
 		// ids no all has the list without 'all' option.
 		this.coll_ids_list_no_all = new String[1];
-		this.coll_ids_list_no_all = (String[]) valid_colls.toArray(coll_ids_list_no_all);
+		this.coll_ids_list_no_all = valid_colls.toArray(coll_ids_list_no_all);
 
 		valid_colls.add(0, "all");
@@ -323,6 +323,6 @@
 		this.coll_ids_list = new String[1];
 		this.coll_names_list = new String[1];
-		this.coll_ids_list = (String[]) valid_colls.toArray(coll_ids_list);
-		this.coll_names_list = (String[]) valid_coll_names.toArray(coll_names_list);
+		this.coll_ids_list = valid_colls.toArray(coll_ids_list);
+		this.coll_names_list = valid_coll_names.toArray(coll_names_list);
 		return true;
 	}
@@ -361,5 +361,5 @@
 
 		// organise the nodes into collection lists
-		HashMap coll_map = new HashMap();
+		HashMap<String, Node> coll_map = new HashMap<String, Node>();
 
 		for (int i = 0; i < query_doc_list.getLength(); i++)
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentBasket.java	(revision 25635)
@@ -72,6 +72,6 @@
 	protected static final String BASKET_BOOK = "documentBasketBook";
 
-	protected Hashtable userMap = null;
-	protected Hashtable timerMap = null;
+	protected Hashtable<String, Hashtable<String, Hashtable<String, Item>>> userMap = null;
+	protected Hashtable<String, UserTimer> timerMap = null;
 	protected String username = "";
 	protected String password = "";
@@ -80,9 +80,9 @@
 	public DocumentBasket()
 	{
-		userMap = new Hashtable();
-		timerMap = new Hashtable();
-	}
-
-	private Hashtable updateDocMap(Element request)
+		userMap = new Hashtable<String, Hashtable<String, Hashtable<String, Item>>>();
+		timerMap = new Hashtable<String, UserTimer>();
+	}
+
+	private Hashtable<String, Hashtable<String, Item>> updateDocMap(Element request)
 	{
 		String id = request.getAttribute("uid");
@@ -92,8 +92,8 @@
 			if (timerMap.containsKey(id))
 			{
-				UserTimer timer = (UserTimer) timerMap.get(id);
+				UserTimer timer = timerMap.get(id);
 				timer.restart();
 			}
-			return (Hashtable) userMap.get(id);
+			return userMap.get(id);
 		}
 		else
@@ -102,5 +102,5 @@
 			timerMap.put(id, timer);
 			timer.start();
-			Hashtable newDocs = new Hashtable();
+			Hashtable<String, Hashtable<String, Item>> newDocs = new Hashtable<String, Hashtable<String, Item>>();
 			userMap.put(id, newDocs);
 			return newDocs;
@@ -226,5 +226,5 @@
 	{
 		//System.err.println("REQUEST = " + GSXML.xmlNodeToString(request));
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 		//System.err.println("DOCSMAP = " + docsMap);
 		// Create a new (empty) result message
@@ -239,5 +239,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		//System.err.println("PARAMS = " + params);
 		String item = (String) params.get("item");
@@ -256,5 +256,5 @@
 		if (docsMap.containsKey(collection))
 		{
-			Hashtable items = (Hashtable) docsMap.get(collection);
+			Hashtable<String, Item> items = docsMap.get(collection);
 			if (!items.containsKey(item))
 			{
@@ -266,5 +266,5 @@
 		else
 		{
-			Hashtable items = new Hashtable();
+			Hashtable<String, Item> items = new Hashtable<String, Item>();
 			Item newItem = generateItem(collection, item);
 			items.put(item, newItem);
@@ -286,5 +286,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String docString = (String) params.get("docs");
@@ -379,5 +379,5 @@
 		Item item = new Item(collection, id);
 		String to = GSPath.appendLink(collection, "DocumentMetadataRetrieve");
-		ArrayList tmp = new ArrayList();
+		ArrayList<String> tmp = new ArrayList<String>();
 		tmp.add(id);
 		
@@ -422,5 +422,5 @@
 	protected Element processClearDocuments(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 		
 		Element result = this.doc.createElement(GSXML.RESPONSE_ELEM);
@@ -435,5 +435,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		String collection = (String) params.get(GSParams.COLLECTION);
 
@@ -441,5 +441,5 @@
 			return result;
 		
-		docsMap.put(collection, new Hashtable());
+		docsMap.put(collection, new Hashtable<String, Item>());
 		
 		return result;
@@ -448,5 +448,5 @@
 	protected Element processDeleteDocuments(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -464,5 +464,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String param = (String) params.get("items");
@@ -489,5 +489,5 @@
 			if (docsMap.containsKey(collection))
 			{
-				Hashtable itemMap = (Hashtable) docsMap.get(collection);
+				Hashtable itemMap = docsMap.get(collection);
 				if (itemMap.containsKey(item))
 				{
@@ -506,5 +506,5 @@
 	protected Element processDeleteDocument(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -522,5 +522,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		String item = (String) params.get("item");
@@ -540,5 +540,5 @@
 		if (docsMap.containsKey(collection))
 		{
-			Hashtable itemMap = (Hashtable) docsMap.get(collection);
+			Hashtable itemMap = docsMap.get(collection);
 			if (itemMap.containsKey(item))
 			{
@@ -557,5 +557,5 @@
 	{
 		// GSXML.printXMLNode(request);
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
@@ -564,9 +564,9 @@
 		int size = 0;
 		String ids = "";
-		Iterator keys = docsMap.keySet().iterator();
+		Iterator<String> keys = docsMap.keySet().iterator();
 
 		while (keys.hasNext())
 		{
-			Hashtable items = (Hashtable) docsMap.get((String) keys.next());
+			Hashtable items = docsMap.get(keys.next());
 			size += items.size();
 			Iterator values = items.values().iterator();
@@ -585,5 +585,5 @@
 	}
 
-	private Element getDocumentMetadata(String to, UserContext userContext, Iterator ids)
+	private Element getDocumentMetadata(String to, UserContext userContext, Iterator<String> ids)
 	{
 
@@ -594,5 +594,5 @@
 
 		// Create a parameter list to specify the required metadata information
-		HashSet meta_names = new HashSet();
+		HashSet<String> meta_names = new HashSet<String>();
 		meta_names.add("Title"); // the default
 		meta_names.add("root_Title");
@@ -602,8 +602,8 @@
 
 		Element param = null;
-		Iterator i = meta_names.iterator();
+		Iterator<String> i = meta_names.iterator();
 		while (i.hasNext())
 		{
-			String name = (String) i.next();
+			String name = i.next();
 			param = this.doc.createElement(GSXML.PARAM_ELEM);
 			param_list.appendChild(param);
@@ -623,5 +623,5 @@
 			Element dm_doc_node = this.doc.createElement(GSXML.DOC_NODE_ELEM);
 			dm_doc_list.appendChild(dm_doc_node);
-			dm_doc_node.setAttribute(GSXML.NODE_ID_ATT, (String) ids.next());
+			dm_doc_node.setAttribute(GSXML.NODE_ID_ATT, ids.next());
 		}
 
@@ -631,15 +631,15 @@
 	protected Element processDisplayDocumentList(Element request)
 	{
-		Hashtable docsMap = updateDocMap(request);
+		Hashtable<String, Hashtable<String, Item>> docsMap = updateDocMap(request);
 
 		// Create a new (empty) result message
 		Element result = this.doc.createElement(GSXML.RESPONSE_ELEM);
 
-		Iterator keys = docsMap.keySet().iterator();
+		Iterator<String> keys = docsMap.keySet().iterator();
 
 		while (keys.hasNext())
 		{
-			String collection = (String) keys.next();
-			Hashtable items = (Hashtable) docsMap.get(collection);
+			String collection = keys.next();
+			Hashtable items = docsMap.get(collection);
 			Iterator itemItr = items.values().iterator();
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 25635)
@@ -25,4 +25,5 @@
 import java.io.InputStreamReader;
 import java.io.OutputStream;
+import java.io.Serializable;
 import java.lang.reflect.Type;
 import java.util.ArrayList;
@@ -370,5 +371,5 @@
 		}
 
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		String transactionString = (String) params.get("transactions");
 		transactionString = transactionString.replace("%26", "&");
@@ -393,5 +394,5 @@
 			for (int j = 0; j < transactions.size(); j++)
 			{
-				Map keyValueMap = (Map) transactions.get(j);
+				Map keyValueMap = transactions.get(j);
 				String operation = (String) keyValueMap.get("operation");
 				if (operation.equals("move") || operation.equals("duplicate"))
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/FedoraServiceProxy.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/FedoraServiceProxy.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/FedoraServiceProxy.java	(revision 25635)
@@ -81,5 +81,5 @@
 	this.doc = this.converter.newDOM();
 	this.short_service_info = this.doc.createElement(GSXML.SERVICE_ELEM+GSXML.LIST_MODIFIER);
-	this.format_info_map = new HashMap();
+	this.format_info_map = new HashMap<String, Node>();
 
     }
@@ -407,5 +407,5 @@
 	NodeList paramNodes = request.getElementsByTagName(GSXML.PARAM_ELEM);
 	if(paramNodes.getLength() > 0) {
-	    HashMap params = new HashMap(paramNodes.getLength());
+	    HashMap<String, String> params = new HashMap<String, String>(paramNodes.getLength());
 	    for(int i = 0; i < paramNodes.getLength(); i++) {
 		Element param = (Element)paramNodes.item(i);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Browse.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Browse.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Browse.java	(revision 25635)
@@ -158,5 +158,5 @@
     }
     /** returns a list of the child ids in order, null if no children */
-    protected ArrayList getChildrenIds(String node_id) {
+    protected ArrayList<String> getChildrenIds(String node_id) {
 	DBInfo info = this.coll_db.getInfo(node_id);
 	if (info == null) {
@@ -164,5 +164,5 @@
 	}
 
-	ArrayList children = new ArrayList();
+	ArrayList<String> children = new ArrayList<String>();
 	
 	String contains = info.getInfo("contains");
@@ -190,8 +190,8 @@
 	}
 
-	Set keys = info.getKeys();
-	Iterator it = keys.iterator();
+	Set<String> keys = info.getKeys();
+	Iterator<String> it = keys.iterator();
 	while(it.hasNext()) {
-	    String key_in = (String)it.next();
+	    String key_in = it.next();
 	    String value = info.getInfo(key);
 	    if (key_in.equals(key)){
@@ -212,5 +212,5 @@
     // assumes only one value per metadata
     protected Element getMetadataList(String node_id, boolean all_metadata, 
-				      ArrayList metadata_names) {
+				      ArrayList<String> metadata_names) {
 	String lang = "en";
 	Element metadata_list = this.doc.createElement(GSXML.METADATA_ELEM+GSXML.LIST_MODIFIER);
@@ -221,8 +221,8 @@
 	if (all_metadata) {
 	    // return everything out of the database
-	    Set keys = info.getKeys();
-	    Iterator it = keys.iterator();
+	    Set<String> keys = info.getKeys();
+	    Iterator<String> it = keys.iterator();
 	    while(it.hasNext()) {
-		String key = (String)it.next();
+		String key = it.next();
 		String value = info.getInfo(key);
 		GSXML.addMetadata(this.doc, metadata_list, key, this.macro_resolver.resolve(value, lang, GS2MacroResolver.SCOPE_META, node_id));
@@ -231,5 +231,5 @@
 	} else {
 	    for (int i=0; i<metadata_names.size(); i++) {
-		String meta_name = (String) metadata_names.get(i);
+		String meta_name = metadata_names.get(i);
 		String value = (String)info.getInfo(meta_name);
 		GSXML.addMetadata(this.doc, metadata_list, meta_name, value);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 25635)
@@ -37,4 +37,5 @@
 import java.io.File;
 import java.io.FileWriter;
+import java.io.Serializable;
 import java.lang.Thread.State;
 import java.util.Locale;
@@ -82,10 +83,10 @@
 
 	// set of listeners for any construction commands
-	protected Map listeners = null;
+	protected Map<String, GS2PerlListener> listeners = null;
 	protected HashMap<String, Boolean> collectionOperationMap = new HashMap<String, Boolean>(); 
 
 	public GS2Construct()
 	{
-		this.listeners = Collections.synchronizedMap(new HashMap());
+		this.listeners = Collections.synchronizedMap(new HashMap<String, GS2PerlListener>());
 	}
 
@@ -175,5 +176,5 @@
 		String id = statusElem.getAttribute("pid");
 
-		GS2PerlListener currentListener = (GS2PerlListener) this.listeners.get(id);
+		GS2PerlListener currentListener = this.listeners.get(id);
 		int statusCode = currentListener.getStatus();
 		while (!GSStatus.isCompleted(statusCode))
@@ -199,5 +200,5 @@
 	{
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		//If we have been requested to only build certain documents then we need to create a manifest file
@@ -264,5 +265,5 @@
 		// the MR about it. but we have to wait until the process is finished.
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		String coll_name = (String) params.get(COL_PARAM);
 		String lang = request.getAttribute(GSXML.LANG_ATT);
@@ -288,5 +289,5 @@
 		}
 		String id = status.getAttribute(GSXML.STATUS_PROCESS_ID_ATT);
-		GS2PerlListener listener = (GS2PerlListener) this.listeners.get(id);
+		GS2PerlListener listener = this.listeners.get(id);
 		if (listener == null)
 		{
@@ -342,5 +343,5 @@
 
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		boolean get_status_only = false;
@@ -400,5 +401,5 @@
 
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		boolean get_status_only = false;
@@ -551,5 +552,5 @@
 
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 
 		boolean get_status_only = false;
@@ -564,5 +565,5 @@
 			String id = (String) params.get(PROCESS_ID_PARAM);
 			status.setAttribute(GSXML.STATUS_PROCESS_ID_ATT, id);
-			GS2PerlListener listener = (GS2PerlListener) this.listeners.get(id);
+			GS2PerlListener listener = this.listeners.get(id);
 			if (listener == null)
 			{
@@ -725,5 +726,5 @@
 	 * element
 	 */
-	protected Element extractOtherParams(HashMap params, int type)
+	protected Element extractOtherParams(HashMap<String, Serializable> params, int type)
 	{
 
@@ -758,5 +759,5 @@
 	{
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		
 		String collection = (String)params.get(COL_PARAM);
@@ -783,5 +784,5 @@
 	{
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(param_list, false);
 		
 		String collection = (String)params.get(COL_PARAM);
